// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: transform.proto

#include "transform.pb.h"

#include <algorithm>

#include <google/protobuf/stubs/common.h>
#include <google/protobuf/stubs/port.h>
#include <google/protobuf/stubs/once.h>
#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/wire_format_lite_inl.h>
#include <google/protobuf/descriptor.h>
#include <google/protobuf/generated_message_reflection.h>
#include <google/protobuf/reflection_ops.h>
#include <google/protobuf/wire_format.h>
// This is a temporary google only hack
#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
#include "third_party/protobuf/version.h"
#endif
// @@protoc_insertion_point(includes)
namespace Transform {
class VectorMsgDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<VectorMsg>
      _instance;
} _VectorMsg_default_instance_;
class QuatMsgDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<QuatMsg>
      _instance;
} _QuatMsg_default_instance_;
class PoseMsgDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<PoseMsg>
      _instance;
} _PoseMsg_default_instance_;
class JointsTransformMsg_JointMsgDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<JointsTransformMsg_JointMsg>
      _instance;
} _JointsTransformMsg_JointMsg_default_instance_;
class JointsTransformMsgDefaultTypeInternal {
 public:
  ::google::protobuf::internal::ExplicitlyConstructed<JointsTransformMsg>
      _instance;
} _JointsTransformMsg_default_instance_;
}  // namespace Transform
namespace protobuf_transform_2eproto {
void InitDefaultsVectorMsgImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::Transform::_VectorMsg_default_instance_;
    new (ptr) ::Transform::VectorMsg();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::Transform::VectorMsg::InitAsDefaultInstance();
}

void InitDefaultsVectorMsg() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsVectorMsgImpl);
}

void InitDefaultsQuatMsgImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  {
    void* ptr = &::Transform::_QuatMsg_default_instance_;
    new (ptr) ::Transform::QuatMsg();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::Transform::QuatMsg::InitAsDefaultInstance();
}

void InitDefaultsQuatMsg() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsQuatMsgImpl);
}

void InitDefaultsPoseMsgImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_transform_2eproto::InitDefaultsVectorMsg();
  protobuf_transform_2eproto::InitDefaultsQuatMsg();
  {
    void* ptr = &::Transform::_PoseMsg_default_instance_;
    new (ptr) ::Transform::PoseMsg();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::Transform::PoseMsg::InitAsDefaultInstance();
}

void InitDefaultsPoseMsg() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsPoseMsgImpl);
}

void InitDefaultsJointsTransformMsg_JointMsgImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_transform_2eproto::InitDefaultsPoseMsg();
  {
    void* ptr = &::Transform::_JointsTransformMsg_JointMsg_default_instance_;
    new (ptr) ::Transform::JointsTransformMsg_JointMsg();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::Transform::JointsTransformMsg_JointMsg::InitAsDefaultInstance();
}

void InitDefaultsJointsTransformMsg_JointMsg() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsJointsTransformMsg_JointMsgImpl);
}

void InitDefaultsJointsTransformMsgImpl() {
  GOOGLE_PROTOBUF_VERIFY_VERSION;

#ifdef GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  ::google::protobuf::internal::InitProtobufDefaultsForceUnique();
#else
  ::google::protobuf::internal::InitProtobufDefaults();
#endif  // GOOGLE_PROTOBUF_ENFORCE_UNIQUENESS
  protobuf_transform_2eproto::InitDefaultsJointsTransformMsg_JointMsg();
  {
    void* ptr = &::Transform::_JointsTransformMsg_default_instance_;
    new (ptr) ::Transform::JointsTransformMsg();
    ::google::protobuf::internal::OnShutdownDestroyMessage(ptr);
  }
  ::Transform::JointsTransformMsg::InitAsDefaultInstance();
}

void InitDefaultsJointsTransformMsg() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &InitDefaultsJointsTransformMsgImpl);
}

::google::protobuf::Metadata file_level_metadata[5];

const ::google::protobuf::uint32 TableStruct::offsets[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::VectorMsg, _has_bits_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::VectorMsg, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::VectorMsg, x_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::VectorMsg, y_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::VectorMsg, z_),
  0,
  1,
  2,
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::QuatMsg, _has_bits_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::QuatMsg, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::QuatMsg, x_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::QuatMsg, y_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::QuatMsg, z_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::QuatMsg, w_),
  0,
  1,
  2,
  3,
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::PoseMsg, _has_bits_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::PoseMsg, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::PoseMsg, vector_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::PoseMsg, quat_),
  0,
  1,
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::JointsTransformMsg_JointMsg, _has_bits_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::JointsTransformMsg_JointMsg, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::JointsTransformMsg_JointMsg, joint_name_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::JointsTransformMsg_JointMsg, pose_),
  0,
  1,
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::JointsTransformMsg, _has_bits_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::JointsTransformMsg, _internal_metadata_),
  ~0u,  // no _extensions_
  ~0u,  // no _oneof_case_
  ~0u,  // no _weak_field_map_
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::JointsTransformMsg, agent_name_),
  GOOGLE_PROTOBUF_GENERATED_MESSAGE_FIELD_OFFSET(::Transform::JointsTransformMsg, joints_transform_),
  0,
  ~0u,
};
static const ::google::protobuf::internal::MigrationSchema schemas[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
  { 0, 8, sizeof(::Transform::VectorMsg)},
  { 11, 20, sizeof(::Transform::QuatMsg)},
  { 24, 31, sizeof(::Transform::PoseMsg)},
  { 33, 40, sizeof(::Transform::JointsTransformMsg_JointMsg)},
  { 42, 49, sizeof(::Transform::JointsTransformMsg)},
};

static ::google::protobuf::Message const * const file_default_instances[] = {
  reinterpret_cast<const ::google::protobuf::Message*>(&::Transform::_VectorMsg_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::Transform::_QuatMsg_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::Transform::_PoseMsg_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::Transform::_JointsTransformMsg_JointMsg_default_instance_),
  reinterpret_cast<const ::google::protobuf::Message*>(&::Transform::_JointsTransformMsg_default_instance_),
};

void protobuf_AssignDescriptors() {
  AddDescriptors();
  ::google::protobuf::MessageFactory* factory = NULL;
  AssignDescriptors(
      "transform.proto", schemas, file_default_instances, TableStruct::offsets, factory,
      file_level_metadata, NULL, NULL);
}

void protobuf_AssignDescriptorsOnce() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &protobuf_AssignDescriptors);
}

void protobuf_RegisterTypes(const ::std::string&) GOOGLE_PROTOBUF_ATTRIBUTE_COLD;
void protobuf_RegisterTypes(const ::std::string&) {
  protobuf_AssignDescriptorsOnce();
  ::google::protobuf::internal::RegisterAllTypes(file_level_metadata, 5);
}

void AddDescriptorsImpl() {
  InitDefaults();
  static const char descriptor[] GOOGLE_PROTOBUF_ATTRIBUTE_SECTION_VARIABLE(protodesc_cold) = {
      "\n\017transform.proto\022\tTransform\"5\n\tVectorMs"
      "g\022\014\n\001x\030\001 \001(\002:\0010\022\014\n\001y\030\002 \001(\002:\0010\022\014\n\001z\030\003 \001(\002"
      ":\0010\"A\n\007QuatMsg\022\014\n\001x\030\001 \001(\002:\0010\022\014\n\001y\030\002 \001(\002:"
      "\0010\022\014\n\001z\030\003 \001(\002:\0010\022\014\n\001w\030\004 \001(\002:\0011\"Q\n\007PoseMs"
      "g\022$\n\006vector\030\001 \001(\0132\024.Transform.VectorMsg\022"
      " \n\004quat\030\002 \001(\0132\022.Transform.QuatMsg\"\260\001\n\022Jo"
      "intsTransformMsg\022\024\n\nagent_name\030\001 \001(\t:\000\022@"
      "\n\020joints_transform\030\002 \003(\0132&.Transform.Joi"
      "ntsTransformMsg.JointMsg\032B\n\010JointMsg\022\024\n\n"
      "joint_name\030\001 \001(\t:\000\022 \n\004pose\030\002 \001(\0132\022.Trans"
      "form.PoseMsg"
  };
  ::google::protobuf::DescriptorPool::InternalAddGeneratedFile(
      descriptor, 412);
  ::google::protobuf::MessageFactory::InternalRegisterGeneratedFile(
    "transform.proto", &protobuf_RegisterTypes);
}

void AddDescriptors() {
  static GOOGLE_PROTOBUF_DECLARE_ONCE(once);
  ::google::protobuf::GoogleOnceInit(&once, &AddDescriptorsImpl);
}
// Force AddDescriptors() to be called at dynamic initialization time.
struct StaticDescriptorInitializer {
  StaticDescriptorInitializer() {
    AddDescriptors();
  }
} static_descriptor_initializer;
}  // namespace protobuf_transform_2eproto
namespace Transform {

// ===================================================================

void VectorMsg::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int VectorMsg::kXFieldNumber;
const int VectorMsg::kYFieldNumber;
const int VectorMsg::kZFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

VectorMsg::VectorMsg()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_transform_2eproto::InitDefaultsVectorMsg();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:Transform.VectorMsg)
}
VectorMsg::VectorMsg(const VectorMsg& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::memcpy(&x_, &from.x_,
    static_cast<size_t>(reinterpret_cast<char*>(&z_) -
    reinterpret_cast<char*>(&x_)) + sizeof(z_));
  // @@protoc_insertion_point(copy_constructor:Transform.VectorMsg)
}

void VectorMsg::SharedCtor() {
  _cached_size_ = 0;
  ::memset(&x_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&z_) -
      reinterpret_cast<char*>(&x_)) + sizeof(z_));
}

VectorMsg::~VectorMsg() {
  // @@protoc_insertion_point(destructor:Transform.VectorMsg)
  SharedDtor();
}

void VectorMsg::SharedDtor() {
}

void VectorMsg::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* VectorMsg::descriptor() {
  ::protobuf_transform_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_transform_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const VectorMsg& VectorMsg::default_instance() {
  ::protobuf_transform_2eproto::InitDefaultsVectorMsg();
  return *internal_default_instance();
}

VectorMsg* VectorMsg::New(::google::protobuf::Arena* arena) const {
  VectorMsg* n = new VectorMsg;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void VectorMsg::Clear() {
// @@protoc_insertion_point(message_clear_start:Transform.VectorMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 7u) {
    ::memset(&x_, 0, static_cast<size_t>(
        reinterpret_cast<char*>(&z_) -
        reinterpret_cast<char*>(&x_)) + sizeof(z_));
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool VectorMsg::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:Transform.VectorMsg)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // optional float x = 1 [default = 0];
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(13u /* 13 & 0xFF */)) {
          set_has_x();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   float, ::google::protobuf::internal::WireFormatLite::TYPE_FLOAT>(
                 input, &x_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional float y = 2 [default = 0];
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(21u /* 21 & 0xFF */)) {
          set_has_y();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   float, ::google::protobuf::internal::WireFormatLite::TYPE_FLOAT>(
                 input, &y_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional float z = 3 [default = 0];
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(29u /* 29 & 0xFF */)) {
          set_has_z();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   float, ::google::protobuf::internal::WireFormatLite::TYPE_FLOAT>(
                 input, &z_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:Transform.VectorMsg)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:Transform.VectorMsg)
  return false;
#undef DO_
}

void VectorMsg::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:Transform.VectorMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional float x = 1 [default = 0];
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteFloat(1, this->x(), output);
  }

  // optional float y = 2 [default = 0];
  if (cached_has_bits & 0x00000002u) {
    ::google::protobuf::internal::WireFormatLite::WriteFloat(2, this->y(), output);
  }

  // optional float z = 3 [default = 0];
  if (cached_has_bits & 0x00000004u) {
    ::google::protobuf::internal::WireFormatLite::WriteFloat(3, this->z(), output);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        _internal_metadata_.unknown_fields(), output);
  }
  // @@protoc_insertion_point(serialize_end:Transform.VectorMsg)
}

::google::protobuf::uint8* VectorMsg::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:Transform.VectorMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional float x = 1 [default = 0];
  if (cached_has_bits & 0x00000001u) {
    target = ::google::protobuf::internal::WireFormatLite::WriteFloatToArray(1, this->x(), target);
  }

  // optional float y = 2 [default = 0];
  if (cached_has_bits & 0x00000002u) {
    target = ::google::protobuf::internal::WireFormatLite::WriteFloatToArray(2, this->y(), target);
  }

  // optional float z = 3 [default = 0];
  if (cached_has_bits & 0x00000004u) {
    target = ::google::protobuf::internal::WireFormatLite::WriteFloatToArray(3, this->z(), target);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        _internal_metadata_.unknown_fields(), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:Transform.VectorMsg)
  return target;
}

size_t VectorMsg::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:Transform.VectorMsg)
  size_t total_size = 0;

  if (_internal_metadata_.have_unknown_fields()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        _internal_metadata_.unknown_fields());
  }
  if (_has_bits_[0 / 32] & 7u) {
    // optional float x = 1 [default = 0];
    if (has_x()) {
      total_size += 1 + 4;
    }

    // optional float y = 2 [default = 0];
    if (has_y()) {
      total_size += 1 + 4;
    }

    // optional float z = 3 [default = 0];
    if (has_z()) {
      total_size += 1 + 4;
    }

  }
  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void VectorMsg::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:Transform.VectorMsg)
  GOOGLE_DCHECK_NE(&from, this);
  const VectorMsg* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const VectorMsg>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:Transform.VectorMsg)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:Transform.VectorMsg)
    MergeFrom(*source);
  }
}

void VectorMsg::MergeFrom(const VectorMsg& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:Transform.VectorMsg)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = from._has_bits_[0];
  if (cached_has_bits & 7u) {
    if (cached_has_bits & 0x00000001u) {
      x_ = from.x_;
    }
    if (cached_has_bits & 0x00000002u) {
      y_ = from.y_;
    }
    if (cached_has_bits & 0x00000004u) {
      z_ = from.z_;
    }
    _has_bits_[0] |= cached_has_bits;
  }
}

void VectorMsg::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:Transform.VectorMsg)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void VectorMsg::CopyFrom(const VectorMsg& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:Transform.VectorMsg)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool VectorMsg::IsInitialized() const {
  return true;
}

void VectorMsg::Swap(VectorMsg* other) {
  if (other == this) return;
  InternalSwap(other);
}
void VectorMsg::InternalSwap(VectorMsg* other) {
  using std::swap;
  swap(x_, other->x_);
  swap(y_, other->y_);
  swap(z_, other->z_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata VectorMsg::GetMetadata() const {
  protobuf_transform_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_transform_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void QuatMsg::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int QuatMsg::kXFieldNumber;
const int QuatMsg::kYFieldNumber;
const int QuatMsg::kZFieldNumber;
const int QuatMsg::kWFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

QuatMsg::QuatMsg()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_transform_2eproto::InitDefaultsQuatMsg();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:Transform.QuatMsg)
}
QuatMsg::QuatMsg(const QuatMsg& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::memcpy(&x_, &from.x_,
    static_cast<size_t>(reinterpret_cast<char*>(&w_) -
    reinterpret_cast<char*>(&x_)) + sizeof(w_));
  // @@protoc_insertion_point(copy_constructor:Transform.QuatMsg)
}

void QuatMsg::SharedCtor() {
  _cached_size_ = 0;
  ::memset(&x_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&z_) -
      reinterpret_cast<char*>(&x_)) + sizeof(z_));
  w_ = 1;
}

QuatMsg::~QuatMsg() {
  // @@protoc_insertion_point(destructor:Transform.QuatMsg)
  SharedDtor();
}

void QuatMsg::SharedDtor() {
}

void QuatMsg::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* QuatMsg::descriptor() {
  ::protobuf_transform_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_transform_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const QuatMsg& QuatMsg::default_instance() {
  ::protobuf_transform_2eproto::InitDefaultsQuatMsg();
  return *internal_default_instance();
}

QuatMsg* QuatMsg::New(::google::protobuf::Arena* arena) const {
  QuatMsg* n = new QuatMsg;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void QuatMsg::Clear() {
// @@protoc_insertion_point(message_clear_start:Transform.QuatMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 15u) {
    ::memset(&x_, 0, static_cast<size_t>(
        reinterpret_cast<char*>(&z_) -
        reinterpret_cast<char*>(&x_)) + sizeof(z_));
    w_ = 1;
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool QuatMsg::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:Transform.QuatMsg)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // optional float x = 1 [default = 0];
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(13u /* 13 & 0xFF */)) {
          set_has_x();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   float, ::google::protobuf::internal::WireFormatLite::TYPE_FLOAT>(
                 input, &x_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional float y = 2 [default = 0];
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(21u /* 21 & 0xFF */)) {
          set_has_y();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   float, ::google::protobuf::internal::WireFormatLite::TYPE_FLOAT>(
                 input, &y_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional float z = 3 [default = 0];
      case 3: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(29u /* 29 & 0xFF */)) {
          set_has_z();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   float, ::google::protobuf::internal::WireFormatLite::TYPE_FLOAT>(
                 input, &z_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional float w = 4 [default = 1];
      case 4: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(37u /* 37 & 0xFF */)) {
          set_has_w();
          DO_((::google::protobuf::internal::WireFormatLite::ReadPrimitive<
                   float, ::google::protobuf::internal::WireFormatLite::TYPE_FLOAT>(
                 input, &w_)));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:Transform.QuatMsg)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:Transform.QuatMsg)
  return false;
#undef DO_
}

void QuatMsg::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:Transform.QuatMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional float x = 1 [default = 0];
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteFloat(1, this->x(), output);
  }

  // optional float y = 2 [default = 0];
  if (cached_has_bits & 0x00000002u) {
    ::google::protobuf::internal::WireFormatLite::WriteFloat(2, this->y(), output);
  }

  // optional float z = 3 [default = 0];
  if (cached_has_bits & 0x00000004u) {
    ::google::protobuf::internal::WireFormatLite::WriteFloat(3, this->z(), output);
  }

  // optional float w = 4 [default = 1];
  if (cached_has_bits & 0x00000008u) {
    ::google::protobuf::internal::WireFormatLite::WriteFloat(4, this->w(), output);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        _internal_metadata_.unknown_fields(), output);
  }
  // @@protoc_insertion_point(serialize_end:Transform.QuatMsg)
}

::google::protobuf::uint8* QuatMsg::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:Transform.QuatMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional float x = 1 [default = 0];
  if (cached_has_bits & 0x00000001u) {
    target = ::google::protobuf::internal::WireFormatLite::WriteFloatToArray(1, this->x(), target);
  }

  // optional float y = 2 [default = 0];
  if (cached_has_bits & 0x00000002u) {
    target = ::google::protobuf::internal::WireFormatLite::WriteFloatToArray(2, this->y(), target);
  }

  // optional float z = 3 [default = 0];
  if (cached_has_bits & 0x00000004u) {
    target = ::google::protobuf::internal::WireFormatLite::WriteFloatToArray(3, this->z(), target);
  }

  // optional float w = 4 [default = 1];
  if (cached_has_bits & 0x00000008u) {
    target = ::google::protobuf::internal::WireFormatLite::WriteFloatToArray(4, this->w(), target);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        _internal_metadata_.unknown_fields(), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:Transform.QuatMsg)
  return target;
}

size_t QuatMsg::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:Transform.QuatMsg)
  size_t total_size = 0;

  if (_internal_metadata_.have_unknown_fields()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        _internal_metadata_.unknown_fields());
  }
  if (_has_bits_[0 / 32] & 15u) {
    // optional float x = 1 [default = 0];
    if (has_x()) {
      total_size += 1 + 4;
    }

    // optional float y = 2 [default = 0];
    if (has_y()) {
      total_size += 1 + 4;
    }

    // optional float z = 3 [default = 0];
    if (has_z()) {
      total_size += 1 + 4;
    }

    // optional float w = 4 [default = 1];
    if (has_w()) {
      total_size += 1 + 4;
    }

  }
  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void QuatMsg::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:Transform.QuatMsg)
  GOOGLE_DCHECK_NE(&from, this);
  const QuatMsg* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const QuatMsg>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:Transform.QuatMsg)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:Transform.QuatMsg)
    MergeFrom(*source);
  }
}

void QuatMsg::MergeFrom(const QuatMsg& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:Transform.QuatMsg)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = from._has_bits_[0];
  if (cached_has_bits & 15u) {
    if (cached_has_bits & 0x00000001u) {
      x_ = from.x_;
    }
    if (cached_has_bits & 0x00000002u) {
      y_ = from.y_;
    }
    if (cached_has_bits & 0x00000004u) {
      z_ = from.z_;
    }
    if (cached_has_bits & 0x00000008u) {
      w_ = from.w_;
    }
    _has_bits_[0] |= cached_has_bits;
  }
}

void QuatMsg::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:Transform.QuatMsg)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void QuatMsg::CopyFrom(const QuatMsg& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:Transform.QuatMsg)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool QuatMsg::IsInitialized() const {
  return true;
}

void QuatMsg::Swap(QuatMsg* other) {
  if (other == this) return;
  InternalSwap(other);
}
void QuatMsg::InternalSwap(QuatMsg* other) {
  using std::swap;
  swap(x_, other->x_);
  swap(y_, other->y_);
  swap(z_, other->z_);
  swap(w_, other->w_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata QuatMsg::GetMetadata() const {
  protobuf_transform_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_transform_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void PoseMsg::InitAsDefaultInstance() {
  ::Transform::_PoseMsg_default_instance_._instance.get_mutable()->vector_ = const_cast< ::Transform::VectorMsg*>(
      ::Transform::VectorMsg::internal_default_instance());
  ::Transform::_PoseMsg_default_instance_._instance.get_mutable()->quat_ = const_cast< ::Transform::QuatMsg*>(
      ::Transform::QuatMsg::internal_default_instance());
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int PoseMsg::kVectorFieldNumber;
const int PoseMsg::kQuatFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

PoseMsg::PoseMsg()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_transform_2eproto::InitDefaultsPoseMsg();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:Transform.PoseMsg)
}
PoseMsg::PoseMsg(const PoseMsg& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  if (from.has_vector()) {
    vector_ = new ::Transform::VectorMsg(*from.vector_);
  } else {
    vector_ = NULL;
  }
  if (from.has_quat()) {
    quat_ = new ::Transform::QuatMsg(*from.quat_);
  } else {
    quat_ = NULL;
  }
  // @@protoc_insertion_point(copy_constructor:Transform.PoseMsg)
}

void PoseMsg::SharedCtor() {
  _cached_size_ = 0;
  ::memset(&vector_, 0, static_cast<size_t>(
      reinterpret_cast<char*>(&quat_) -
      reinterpret_cast<char*>(&vector_)) + sizeof(quat_));
}

PoseMsg::~PoseMsg() {
  // @@protoc_insertion_point(destructor:Transform.PoseMsg)
  SharedDtor();
}

void PoseMsg::SharedDtor() {
  if (this != internal_default_instance()) delete vector_;
  if (this != internal_default_instance()) delete quat_;
}

void PoseMsg::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* PoseMsg::descriptor() {
  ::protobuf_transform_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_transform_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const PoseMsg& PoseMsg::default_instance() {
  ::protobuf_transform_2eproto::InitDefaultsPoseMsg();
  return *internal_default_instance();
}

PoseMsg* PoseMsg::New(::google::protobuf::Arena* arena) const {
  PoseMsg* n = new PoseMsg;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void PoseMsg::Clear() {
// @@protoc_insertion_point(message_clear_start:Transform.PoseMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 3u) {
    if (cached_has_bits & 0x00000001u) {
      GOOGLE_DCHECK(vector_ != NULL);
      vector_->Clear();
    }
    if (cached_has_bits & 0x00000002u) {
      GOOGLE_DCHECK(quat_ != NULL);
      quat_->Clear();
    }
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool PoseMsg::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:Transform.PoseMsg)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // optional .Transform.VectorMsg vector = 1;
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_vector()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional .Transform.QuatMsg quat = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_quat()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:Transform.PoseMsg)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:Transform.PoseMsg)
  return false;
#undef DO_
}

void PoseMsg::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:Transform.PoseMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional .Transform.VectorMsg vector = 1;
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      1, *this->vector_, output);
  }

  // optional .Transform.QuatMsg quat = 2;
  if (cached_has_bits & 0x00000002u) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      2, *this->quat_, output);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        _internal_metadata_.unknown_fields(), output);
  }
  // @@protoc_insertion_point(serialize_end:Transform.PoseMsg)
}

::google::protobuf::uint8* PoseMsg::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:Transform.PoseMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional .Transform.VectorMsg vector = 1;
  if (cached_has_bits & 0x00000001u) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        1, *this->vector_, deterministic, target);
  }

  // optional .Transform.QuatMsg quat = 2;
  if (cached_has_bits & 0x00000002u) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        2, *this->quat_, deterministic, target);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        _internal_metadata_.unknown_fields(), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:Transform.PoseMsg)
  return target;
}

size_t PoseMsg::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:Transform.PoseMsg)
  size_t total_size = 0;

  if (_internal_metadata_.have_unknown_fields()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        _internal_metadata_.unknown_fields());
  }
  if (_has_bits_[0 / 32] & 3u) {
    // optional .Transform.VectorMsg vector = 1;
    if (has_vector()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *this->vector_);
    }

    // optional .Transform.QuatMsg quat = 2;
    if (has_quat()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *this->quat_);
    }

  }
  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void PoseMsg::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:Transform.PoseMsg)
  GOOGLE_DCHECK_NE(&from, this);
  const PoseMsg* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const PoseMsg>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:Transform.PoseMsg)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:Transform.PoseMsg)
    MergeFrom(*source);
  }
}

void PoseMsg::MergeFrom(const PoseMsg& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:Transform.PoseMsg)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = from._has_bits_[0];
  if (cached_has_bits & 3u) {
    if (cached_has_bits & 0x00000001u) {
      mutable_vector()->::Transform::VectorMsg::MergeFrom(from.vector());
    }
    if (cached_has_bits & 0x00000002u) {
      mutable_quat()->::Transform::QuatMsg::MergeFrom(from.quat());
    }
  }
}

void PoseMsg::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:Transform.PoseMsg)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void PoseMsg::CopyFrom(const PoseMsg& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:Transform.PoseMsg)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool PoseMsg::IsInitialized() const {
  return true;
}

void PoseMsg::Swap(PoseMsg* other) {
  if (other == this) return;
  InternalSwap(other);
}
void PoseMsg::InternalSwap(PoseMsg* other) {
  using std::swap;
  swap(vector_, other->vector_);
  swap(quat_, other->quat_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata PoseMsg::GetMetadata() const {
  protobuf_transform_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_transform_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void JointsTransformMsg_JointMsg::InitAsDefaultInstance() {
  ::Transform::_JointsTransformMsg_JointMsg_default_instance_._instance.get_mutable()->pose_ = const_cast< ::Transform::PoseMsg*>(
      ::Transform::PoseMsg::internal_default_instance());
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int JointsTransformMsg_JointMsg::kJointNameFieldNumber;
const int JointsTransformMsg_JointMsg::kPoseFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

JointsTransformMsg_JointMsg::JointsTransformMsg_JointMsg()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_transform_2eproto::InitDefaultsJointsTransformMsg_JointMsg();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:Transform.JointsTransformMsg.JointMsg)
}
JointsTransformMsg_JointMsg::JointsTransformMsg_JointMsg(const JointsTransformMsg_JointMsg& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_),
      _cached_size_(0) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  joint_name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.has_joint_name()) {
    joint_name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.joint_name_);
  }
  if (from.has_pose()) {
    pose_ = new ::Transform::PoseMsg(*from.pose_);
  } else {
    pose_ = NULL;
  }
  // @@protoc_insertion_point(copy_constructor:Transform.JointsTransformMsg.JointMsg)
}

void JointsTransformMsg_JointMsg::SharedCtor() {
  _cached_size_ = 0;
  joint_name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  pose_ = NULL;
}

JointsTransformMsg_JointMsg::~JointsTransformMsg_JointMsg() {
  // @@protoc_insertion_point(destructor:Transform.JointsTransformMsg.JointMsg)
  SharedDtor();
}

void JointsTransformMsg_JointMsg::SharedDtor() {
  joint_name_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (this != internal_default_instance()) delete pose_;
}

void JointsTransformMsg_JointMsg::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* JointsTransformMsg_JointMsg::descriptor() {
  ::protobuf_transform_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_transform_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const JointsTransformMsg_JointMsg& JointsTransformMsg_JointMsg::default_instance() {
  ::protobuf_transform_2eproto::InitDefaultsJointsTransformMsg_JointMsg();
  return *internal_default_instance();
}

JointsTransformMsg_JointMsg* JointsTransformMsg_JointMsg::New(::google::protobuf::Arena* arena) const {
  JointsTransformMsg_JointMsg* n = new JointsTransformMsg_JointMsg;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void JointsTransformMsg_JointMsg::Clear() {
// @@protoc_insertion_point(message_clear_start:Transform.JointsTransformMsg.JointMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 3u) {
    if (cached_has_bits & 0x00000001u) {
      GOOGLE_DCHECK(!joint_name_.IsDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited()));
      (*joint_name_.UnsafeRawStringPointer())->clear();
    }
    if (cached_has_bits & 0x00000002u) {
      GOOGLE_DCHECK(pose_ != NULL);
      pose_->Clear();
    }
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool JointsTransformMsg_JointMsg::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:Transform.JointsTransformMsg.JointMsg)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // optional string joint_name = 1 [default = ""];
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_joint_name()));
          ::google::protobuf::internal::WireFormat::VerifyUTF8StringNamedField(
            this->joint_name().data(), static_cast<int>(this->joint_name().length()),
            ::google::protobuf::internal::WireFormat::PARSE,
            "Transform.JointsTransformMsg.JointMsg.joint_name");
        } else {
          goto handle_unusual;
        }
        break;
      }

      // optional .Transform.PoseMsg pose = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(
               input, mutable_pose()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:Transform.JointsTransformMsg.JointMsg)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:Transform.JointsTransformMsg.JointMsg)
  return false;
#undef DO_
}

void JointsTransformMsg_JointMsg::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:Transform.JointsTransformMsg.JointMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional string joint_name = 1 [default = ""];
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormat::VerifyUTF8StringNamedField(
      this->joint_name().data(), static_cast<int>(this->joint_name().length()),
      ::google::protobuf::internal::WireFormat::SERIALIZE,
      "Transform.JointsTransformMsg.JointMsg.joint_name");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->joint_name(), output);
  }

  // optional .Transform.PoseMsg pose = 2;
  if (cached_has_bits & 0x00000002u) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      2, *this->pose_, output);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        _internal_metadata_.unknown_fields(), output);
  }
  // @@protoc_insertion_point(serialize_end:Transform.JointsTransformMsg.JointMsg)
}

::google::protobuf::uint8* JointsTransformMsg_JointMsg::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:Transform.JointsTransformMsg.JointMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional string joint_name = 1 [default = ""];
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormat::VerifyUTF8StringNamedField(
      this->joint_name().data(), static_cast<int>(this->joint_name().length()),
      ::google::protobuf::internal::WireFormat::SERIALIZE,
      "Transform.JointsTransformMsg.JointMsg.joint_name");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->joint_name(), target);
  }

  // optional .Transform.PoseMsg pose = 2;
  if (cached_has_bits & 0x00000002u) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        2, *this->pose_, deterministic, target);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        _internal_metadata_.unknown_fields(), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:Transform.JointsTransformMsg.JointMsg)
  return target;
}

size_t JointsTransformMsg_JointMsg::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:Transform.JointsTransformMsg.JointMsg)
  size_t total_size = 0;

  if (_internal_metadata_.have_unknown_fields()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        _internal_metadata_.unknown_fields());
  }
  if (_has_bits_[0 / 32] & 3u) {
    // optional string joint_name = 1 [default = ""];
    if (has_joint_name()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::StringSize(
          this->joint_name());
    }

    // optional .Transform.PoseMsg pose = 2;
    if (has_pose()) {
      total_size += 1 +
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          *this->pose_);
    }

  }
  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void JointsTransformMsg_JointMsg::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:Transform.JointsTransformMsg.JointMsg)
  GOOGLE_DCHECK_NE(&from, this);
  const JointsTransformMsg_JointMsg* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const JointsTransformMsg_JointMsg>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:Transform.JointsTransformMsg.JointMsg)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:Transform.JointsTransformMsg.JointMsg)
    MergeFrom(*source);
  }
}

void JointsTransformMsg_JointMsg::MergeFrom(const JointsTransformMsg_JointMsg& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:Transform.JointsTransformMsg.JointMsg)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = from._has_bits_[0];
  if (cached_has_bits & 3u) {
    if (cached_has_bits & 0x00000001u) {
      set_has_joint_name();
      joint_name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.joint_name_);
    }
    if (cached_has_bits & 0x00000002u) {
      mutable_pose()->::Transform::PoseMsg::MergeFrom(from.pose());
    }
  }
}

void JointsTransformMsg_JointMsg::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:Transform.JointsTransformMsg.JointMsg)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void JointsTransformMsg_JointMsg::CopyFrom(const JointsTransformMsg_JointMsg& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:Transform.JointsTransformMsg.JointMsg)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool JointsTransformMsg_JointMsg::IsInitialized() const {
  return true;
}

void JointsTransformMsg_JointMsg::Swap(JointsTransformMsg_JointMsg* other) {
  if (other == this) return;
  InternalSwap(other);
}
void JointsTransformMsg_JointMsg::InternalSwap(JointsTransformMsg_JointMsg* other) {
  using std::swap;
  joint_name_.Swap(&other->joint_name_);
  swap(pose_, other->pose_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata JointsTransformMsg_JointMsg::GetMetadata() const {
  protobuf_transform_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_transform_2eproto::file_level_metadata[kIndexInFileMessages];
}


// ===================================================================

void JointsTransformMsg::InitAsDefaultInstance() {
}
#if !defined(_MSC_VER) || _MSC_VER >= 1900
const int JointsTransformMsg::kAgentNameFieldNumber;
const int JointsTransformMsg::kJointsTransformFieldNumber;
#endif  // !defined(_MSC_VER) || _MSC_VER >= 1900

JointsTransformMsg::JointsTransformMsg()
  : ::google::protobuf::Message(), _internal_metadata_(NULL) {
  if (GOOGLE_PREDICT_TRUE(this != internal_default_instance())) {
    ::protobuf_transform_2eproto::InitDefaultsJointsTransformMsg();
  }
  SharedCtor();
  // @@protoc_insertion_point(constructor:Transform.JointsTransformMsg)
}
JointsTransformMsg::JointsTransformMsg(const JointsTransformMsg& from)
  : ::google::protobuf::Message(),
      _internal_metadata_(NULL),
      _has_bits_(from._has_bits_),
      _cached_size_(0),
      joints_transform_(from.joints_transform_) {
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  agent_name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
  if (from.has_agent_name()) {
    agent_name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.agent_name_);
  }
  // @@protoc_insertion_point(copy_constructor:Transform.JointsTransformMsg)
}

void JointsTransformMsg::SharedCtor() {
  _cached_size_ = 0;
  agent_name_.UnsafeSetDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

JointsTransformMsg::~JointsTransformMsg() {
  // @@protoc_insertion_point(destructor:Transform.JointsTransformMsg)
  SharedDtor();
}

void JointsTransformMsg::SharedDtor() {
  agent_name_.DestroyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}

void JointsTransformMsg::SetCachedSize(int size) const {
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
}
const ::google::protobuf::Descriptor* JointsTransformMsg::descriptor() {
  ::protobuf_transform_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_transform_2eproto::file_level_metadata[kIndexInFileMessages].descriptor;
}

const JointsTransformMsg& JointsTransformMsg::default_instance() {
  ::protobuf_transform_2eproto::InitDefaultsJointsTransformMsg();
  return *internal_default_instance();
}

JointsTransformMsg* JointsTransformMsg::New(::google::protobuf::Arena* arena) const {
  JointsTransformMsg* n = new JointsTransformMsg;
  if (arena != NULL) {
    arena->Own(n);
  }
  return n;
}

void JointsTransformMsg::Clear() {
// @@protoc_insertion_point(message_clear_start:Transform.JointsTransformMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  // Prevent compiler warnings about cached_has_bits being unused
  (void) cached_has_bits;

  joints_transform_.Clear();
  cached_has_bits = _has_bits_[0];
  if (cached_has_bits & 0x00000001u) {
    GOOGLE_DCHECK(!agent_name_.IsDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited()));
    (*agent_name_.UnsafeRawStringPointer())->clear();
  }
  _has_bits_.Clear();
  _internal_metadata_.Clear();
}

bool JointsTransformMsg::MergePartialFromCodedStream(
    ::google::protobuf::io::CodedInputStream* input) {
#define DO_(EXPRESSION) if (!GOOGLE_PREDICT_TRUE(EXPRESSION)) goto failure
  ::google::protobuf::uint32 tag;
  // @@protoc_insertion_point(parse_start:Transform.JointsTransformMsg)
  for (;;) {
    ::std::pair< ::google::protobuf::uint32, bool> p = input->ReadTagWithCutoffNoLastTag(127u);
    tag = p.first;
    if (!p.second) goto handle_unusual;
    switch (::google::protobuf::internal::WireFormatLite::GetTagFieldNumber(tag)) {
      // optional string agent_name = 1 [default = ""];
      case 1: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(10u /* 10 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadString(
                input, this->mutable_agent_name()));
          ::google::protobuf::internal::WireFormat::VerifyUTF8StringNamedField(
            this->agent_name().data(), static_cast<int>(this->agent_name().length()),
            ::google::protobuf::internal::WireFormat::PARSE,
            "Transform.JointsTransformMsg.agent_name");
        } else {
          goto handle_unusual;
        }
        break;
      }

      // repeated .Transform.JointsTransformMsg.JointMsg joints_transform = 2;
      case 2: {
        if (static_cast< ::google::protobuf::uint8>(tag) ==
            static_cast< ::google::protobuf::uint8>(18u /* 18 & 0xFF */)) {
          DO_(::google::protobuf::internal::WireFormatLite::ReadMessage(input, add_joints_transform()));
        } else {
          goto handle_unusual;
        }
        break;
      }

      default: {
      handle_unusual:
        if (tag == 0) {
          goto success;
        }
        DO_(::google::protobuf::internal::WireFormat::SkipField(
              input, tag, _internal_metadata_.mutable_unknown_fields()));
        break;
      }
    }
  }
success:
  // @@protoc_insertion_point(parse_success:Transform.JointsTransformMsg)
  return true;
failure:
  // @@protoc_insertion_point(parse_failure:Transform.JointsTransformMsg)
  return false;
#undef DO_
}

void JointsTransformMsg::SerializeWithCachedSizes(
    ::google::protobuf::io::CodedOutputStream* output) const {
  // @@protoc_insertion_point(serialize_start:Transform.JointsTransformMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional string agent_name = 1 [default = ""];
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormat::VerifyUTF8StringNamedField(
      this->agent_name().data(), static_cast<int>(this->agent_name().length()),
      ::google::protobuf::internal::WireFormat::SERIALIZE,
      "Transform.JointsTransformMsg.agent_name");
    ::google::protobuf::internal::WireFormatLite::WriteStringMaybeAliased(
      1, this->agent_name(), output);
  }

  // repeated .Transform.JointsTransformMsg.JointMsg joints_transform = 2;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->joints_transform_size()); i < n; i++) {
    ::google::protobuf::internal::WireFormatLite::WriteMessageMaybeToArray(
      2, this->joints_transform(static_cast<int>(i)), output);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    ::google::protobuf::internal::WireFormat::SerializeUnknownFields(
        _internal_metadata_.unknown_fields(), output);
  }
  // @@protoc_insertion_point(serialize_end:Transform.JointsTransformMsg)
}

::google::protobuf::uint8* JointsTransformMsg::InternalSerializeWithCachedSizesToArray(
    bool deterministic, ::google::protobuf::uint8* target) const {
  (void)deterministic; // Unused
  // @@protoc_insertion_point(serialize_to_array_start:Transform.JointsTransformMsg)
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  cached_has_bits = _has_bits_[0];
  // optional string agent_name = 1 [default = ""];
  if (cached_has_bits & 0x00000001u) {
    ::google::protobuf::internal::WireFormat::VerifyUTF8StringNamedField(
      this->agent_name().data(), static_cast<int>(this->agent_name().length()),
      ::google::protobuf::internal::WireFormat::SERIALIZE,
      "Transform.JointsTransformMsg.agent_name");
    target =
      ::google::protobuf::internal::WireFormatLite::WriteStringToArray(
        1, this->agent_name(), target);
  }

  // repeated .Transform.JointsTransformMsg.JointMsg joints_transform = 2;
  for (unsigned int i = 0,
      n = static_cast<unsigned int>(this->joints_transform_size()); i < n; i++) {
    target = ::google::protobuf::internal::WireFormatLite::
      InternalWriteMessageToArray(
        2, this->joints_transform(static_cast<int>(i)), deterministic, target);
  }

  if (_internal_metadata_.have_unknown_fields()) {
    target = ::google::protobuf::internal::WireFormat::SerializeUnknownFieldsToArray(
        _internal_metadata_.unknown_fields(), target);
  }
  // @@protoc_insertion_point(serialize_to_array_end:Transform.JointsTransformMsg)
  return target;
}

size_t JointsTransformMsg::ByteSizeLong() const {
// @@protoc_insertion_point(message_byte_size_start:Transform.JointsTransformMsg)
  size_t total_size = 0;

  if (_internal_metadata_.have_unknown_fields()) {
    total_size +=
      ::google::protobuf::internal::WireFormat::ComputeUnknownFieldsSize(
        _internal_metadata_.unknown_fields());
  }
  // repeated .Transform.JointsTransformMsg.JointMsg joints_transform = 2;
  {
    unsigned int count = static_cast<unsigned int>(this->joints_transform_size());
    total_size += 1UL * count;
    for (unsigned int i = 0; i < count; i++) {
      total_size +=
        ::google::protobuf::internal::WireFormatLite::MessageSize(
          this->joints_transform(static_cast<int>(i)));
    }
  }

  // optional string agent_name = 1 [default = ""];
  if (has_agent_name()) {
    total_size += 1 +
      ::google::protobuf::internal::WireFormatLite::StringSize(
        this->agent_name());
  }

  int cached_size = ::google::protobuf::internal::ToCachedSize(total_size);
  GOOGLE_SAFE_CONCURRENT_WRITES_BEGIN();
  _cached_size_ = cached_size;
  GOOGLE_SAFE_CONCURRENT_WRITES_END();
  return total_size;
}

void JointsTransformMsg::MergeFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_merge_from_start:Transform.JointsTransformMsg)
  GOOGLE_DCHECK_NE(&from, this);
  const JointsTransformMsg* source =
      ::google::protobuf::internal::DynamicCastToGenerated<const JointsTransformMsg>(
          &from);
  if (source == NULL) {
  // @@protoc_insertion_point(generalized_merge_from_cast_fail:Transform.JointsTransformMsg)
    ::google::protobuf::internal::ReflectionOps::Merge(from, this);
  } else {
  // @@protoc_insertion_point(generalized_merge_from_cast_success:Transform.JointsTransformMsg)
    MergeFrom(*source);
  }
}

void JointsTransformMsg::MergeFrom(const JointsTransformMsg& from) {
// @@protoc_insertion_point(class_specific_merge_from_start:Transform.JointsTransformMsg)
  GOOGLE_DCHECK_NE(&from, this);
  _internal_metadata_.MergeFrom(from._internal_metadata_);
  ::google::protobuf::uint32 cached_has_bits = 0;
  (void) cached_has_bits;

  joints_transform_.MergeFrom(from.joints_transform_);
  if (from.has_agent_name()) {
    set_has_agent_name();
    agent_name_.AssignWithDefault(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), from.agent_name_);
  }
}

void JointsTransformMsg::CopyFrom(const ::google::protobuf::Message& from) {
// @@protoc_insertion_point(generalized_copy_from_start:Transform.JointsTransformMsg)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

void JointsTransformMsg::CopyFrom(const JointsTransformMsg& from) {
// @@protoc_insertion_point(class_specific_copy_from_start:Transform.JointsTransformMsg)
  if (&from == this) return;
  Clear();
  MergeFrom(from);
}

bool JointsTransformMsg::IsInitialized() const {
  return true;
}

void JointsTransformMsg::Swap(JointsTransformMsg* other) {
  if (other == this) return;
  InternalSwap(other);
}
void JointsTransformMsg::InternalSwap(JointsTransformMsg* other) {
  using std::swap;
  joints_transform_.InternalSwap(&other->joints_transform_);
  agent_name_.Swap(&other->agent_name_);
  swap(_has_bits_[0], other->_has_bits_[0]);
  _internal_metadata_.Swap(&other->_internal_metadata_);
  swap(_cached_size_, other->_cached_size_);
}

::google::protobuf::Metadata JointsTransformMsg::GetMetadata() const {
  protobuf_transform_2eproto::protobuf_AssignDescriptorsOnce();
  return ::protobuf_transform_2eproto::file_level_metadata[kIndexInFileMessages];
}


// @@protoc_insertion_point(namespace_scope)
}  // namespace Transform

// @@protoc_insertion_point(global_scope)
